function initialize_snake
I = double(imread('Cat GEMS - Slice 4.png'));
I(:) = (I-min(I(:)))/(max(I(:))-min(I(:)));
figure(1),imagesc(I),colormap(gray),axis image;

cx=250;cy=200; % appriximate center location, should intersect the cord
[cx,cy,theta] = symmetry_axis(I,cx,cy);

[h,w] = size(I);
[X,Y] = meshgrid(1:w,1:h);
Xr = min(w,max(1,cx + (X-cx)*cos(theta) - (Y-cy)*sin(theta)));
Yr = min(h,max(1,cy + (X-cx)*sin(theta) + (Y-cy)*cos(theta)));

J = interp2(I,Xr,Yr,'bicubic');
figure(2),imagesc(J),colormap(gray),axis image;


% build horizontal barriers
c = (cx-200:cx+200)';
r = cy*ones(2*200+1,1);
figure(2),hold on; plot(c,r,'r.'); hold off; 
horz_bar1 = (c-1)*h + r;

c = [(cx-100:cx-2)'; (cx+2:cx+100)'];
r = round((cy+1)/2)*ones(length(c),1);
figure(2),hold on; plot(c,r,'r.'); hold off; 
horz_bar2 = (c-1)*h + r;

c = [(cx-100:cx-2)'; (cx+2:cx+100)'];
r = round((cy+h)/2)*ones(length(c),1);
figure(2),hold on; plot(c,r,'r.'); hold off; 
horz_bar3 = (c-1)*h + r;

% build vertical barriers 
c = cx*ones(h,1);
r = (1:h)';
vert_bar1 = (c-1)*h + r;
figure(2),hold on; plot(c,r,'g.'); hold off; 

r = (round((cy+1)/2):round((cy+h)/2))';
c = (cx-100)*ones(length(r),1);
vert_bar2 = (c-1)*h + r;
figure(2),hold on; plot(c,r,'g.'); hold off; 

r = (round((cy+1)/2):round((cy+h)/2))';
c = (cx+100)*ones(length(r),1);
vert_bar3 = (c-1)*h + r;
figure(2),hold on; plot(c,r,'g.'); hold off; 

sig = 1;
siz = 2*round(3*sig) + 1;
g = fspecial('Gaussian',[siz siz],sig);
J = imfilter(J,g,'same','same','replicate');

[Jx,Jy] = gradient(J);
smlG = sqrt(Jx.^2 + Jy.^2);
smlT = atan2(Jy, Jx);

% build an edge weight (adjacency matrix)
rowC = [1:h];         rowN = [1 1:h-1];    rowS = [2:h h];
colC = [1:w];         colE = [1 1:w-1];    colW = [2:w w];

% gradient based cost function
sg=0.01;
sa=1;
CN = exp(-(smlG(rowN,colC)+smlG).^2/(2*sg^2) -(smlT(rowN,colC) - smlT).^2/(2*sa^2));
CS = exp(-(smlG(rowS,colC)+smlG).^2/(2*sg^2) -(smlT(rowS,colC) - smlT).^2/(2*sa^2));
CE = exp(-(smlG(rowC,colE)+smlG).^2/(2*sg^2) -(smlT(rowC,colE) - smlT).^2/(2*sa^2));
CW = exp(-(smlG(rowC,colW)+smlG).^2/(2*sg^2) -(smlT(rowC,colW) - smlT).^2/(2*sa^2));
CNE = exp(-(smlG(rowN,colE)+smlG).^2/(2*sg^2) -(smlT(rowN,colE) - smlT).^2/(2*sa^2));
CSE = exp(-(smlG(rowS,colE)+smlG).^2/(2*sg^2) -(smlT(rowS,colE) - smlT).^2/(2*sa^2));
CNW = exp(-(smlG(rowN,colW)+smlG).^2/(2*sg^2) -(smlT(rowN,colW) - smlT).^2/(2*sa^2));
CSW = exp(-(smlG(rowS,colW)+smlG).^2/(2*sg^2) -(smlT(rowS,colW) - smlT).^2/(2*sa^2));

% adjacency matrix construction
% prevent wrap-around edges
CS(1:h:(w-1)*h+1)=0;
CNW(h:h:w*h)=0;
CSW(1:h:(w-1)*h+1)=0;
CN(h:h:w*h)=0;
CSE(1:h:(w-1)*h+1)=0;
CNE(h:h:w*h)=0;

% create a barriers
CS(horz_bar1)=0; CNW(horz_bar1)=0; CSW(horz_bar1)=0; CN(horz_bar1)=0; CSE(horz_bar1)=0; CNE(horz_bar1)=0; CE(horz_bar1)=0; CW(horz_bar1)=0;
CS(horz_bar2)=0; CNW(horz_bar2)=0; CSW(horz_bar2)=0; CN(horz_bar2)=0; CSE(horz_bar2)=0; CNE(horz_bar2)=0; CE(horz_bar2)=0; CW(horz_bar2)=0;
CS(horz_bar3)=0; CNW(horz_bar3)=0; CSW(horz_bar3)=0; CN(horz_bar3)=0; CSE(horz_bar3)=0; CNE(horz_bar3)=0; CE(horz_bar3)=0; CW(horz_bar3)=0;
CS(vert_bar1)=0; CNW(vert_bar1)=0; CSW(vert_bar1)=0; CN(vert_bar1)=0; CSE(vert_bar1)=0; CNE(vert_bar1)=0; CE(vert_bar1)=0; CW(vert_bar1)=0;
CS(vert_bar2)=0; CNW(vert_bar2)=0; CSW(vert_bar2)=0; CN(vert_bar2)=0; CSE(vert_bar2)=0; CNE(vert_bar2)=0; CE(vert_bar2)=0; CW(vert_bar2)=0;
CS(vert_bar3)=0; CNW(vert_bar3)=0; CSW(vert_bar3)=0; CN(vert_bar3)=0; CSE(vert_bar3)=0; CNE(vert_bar3)=0; CE(vert_bar3)=0; CW(vert_bar3)=0;

% this is a quick way to build the adjacency matrix
A = spdiags([CNE(:) CE(:) CSE(:) CN(:) CS(:) CNW(:) CW(:) CSW(:)],[-h-1 -h -h+1 -1 1 h-1 h h+1],h*w,h*w);


p1y = cy-1; p2y = cy+1;
p1x = cx-50; p2x = p1x;


u = (p1x-1)*h+p1y;
[dists pred] = shortest_paths(A,u);
i=p2y;
j=p2x;
x=[];y=[];
while ~(i==p1y && j==p1x)
    x = [x; j];
    y = [y; i];
    ind = pred(h*(j-1)+i);
    j = floor((ind-1)/h) + 1;
    i = ind - h*(j-1);
end
x=[x; p1x];
y=[y; p1y];
figure(2),hold on; plot(x,y,'c'); hold off;


p1y = cy-1; p2y = cy+1;
p1x = cx+50; p2x = p1x;


u = (p1x-1)*h+p1y;
[dists pred] = shortest_paths(A,u);
i=p2y;
j=p2x;
x=[];y=[];
while ~(i==p1y && j==p1x)
    x = [x; j];
    y = [y; i];
    ind = pred(h*(j-1)+i);
    j = floor((ind-1)/h) + 1;
    i = ind - h*(j-1);
end
x=[x; p1x];
y=[y; p1y];
figure(2),hold on; plot(x,y,'y'); hold off;
title('Undoing rotation');
xlabel('Thick lines are barriers');

function [cx,cy,theta] = symmetry_axis(I,cx,cy)
% I = double(imread('Cat GEMS - Slice 1.png'));
I(:) = 255*(I-min(I(:)))/(max(I(:))-min(I(:)));
figure(1),imagesc(I),colormap(gray),axis image;

% refine the center cx,cy
level = graythresh(I/255); % otsu threshold
B = bwselect(I>=(255*level),cx,cy);
% figure(2),imagesc(I>=(255*level)),colormap(gray),axis image;
% return;
stat = regionprops(double(B),'Centroid');

cx = round(stat.Centroid(1));
cy = round(stat.Centroid(2));
hold on; plot(cx,cy,'r*'); hold off;

% now find the axis of symmetry based on Bhattacharya coefficient
% in principle should be more robust than say pixel to pixel SSD, however I have
% not checked that...

bins=0:1:255;
r=100;
t = linspace(0,pi/16,10)'-pi/2;

% assumes maximum rotation is within this range - can be increased if
% needed, only 20 intermediate graduations are considered - can be
% increased
s = linspace(-pi/8,pi/8,20);

% not the optimized version, lots of room for speed up
max_bc=0;
max_n=0;
for n=1:length(s),
    bc=0;
    for i=0:15, % consider 16 symmetric regions, I just chose this 16 number arbitrarily 
        x1 = cx + r*cos(t+i*pi/16);
        y1 = cy + r*sin(t+i*pi/16);
        x2 = 2*cx - x1;
        y2 = y1;
        
        % rotation
        x1r = cx + (x1-cx)*cos(s(n))-(y1-cx)*sin(s(n));
        y1r = cy + (x1-cx)*sin(s(n))+(y1-cy)*cos(s(n));
        x2r = cx + (x2-cx)*cos(s(n))-(y2-cx)*sin(s(n));
        y2r = cy + (x2-cx)*sin(s(n))+(y2-cy)*cos(s(n));
        
%         figure(1),imagesc(I),colormap(gray),axis image;
%         hold on; plot(x1r,y1r,'r',x2r,y2r,'g'); hold off;
%         pause; 
        BW1 = roipoly(I,[cx;x1r;cx],[cy;y1r;cy]);
        BW2 = roipoly(I,[cx;x2r;cx],[cy;y2r;cy]);

        H1 = hist(I(BW1),bins);
        H1(:) = H1/sum(H1);
        H2 = hist(I(BW2),bins);
        H2(:) = H2/sum(H2);
        
        % Bhattacharya coefficient computation
        bc = bc + sum(sqrt(H1).*sqrt(H2));
    end
    if bc>max_bc,
        max_bc = bc;
        max_n=n;
    end
end
x1 = cx + 2*r*cos(s(max_n)+pi/2);
y1 = cy + 2*r*sin(s(max_n)+pi/2);
x2 = cx - 2*r*cos(s(max_n)+pi/2);
y2 = cy - 2*r*sin(s(max_n)+pi/2);
hold on; plot([x1 x2],[y1 y2],'y'); hold off;
theta = s(max_n);
